Attribute VB_Name = "ObjectsProperties"
Option Explicit

Public Type AttachmentProps
  id_mensaje As Long
  uri As String * 255
End Type

Public Type AttachmentData
  Buffer As String * 260
End Type

Public Type EmoticonProps
  id_emoticon As Long
  uri As String * 255
End Type

Public Type EmoticonData
  Buffer As String * 260
End Type

Public Type ForoProps
  id_foro As Long
  nombre As String * 20
  descripcion As String * 255
  es_activo As String * 1
  fecha_creacion As Date
  num_visitas As Long
  fecha_ultima_visita As Date
  num_topicos As Long
End Type

Public Type ForoData
  Buffer As String * 290
End Type

Public Type MensajeProps
  id_mensaje As Long
  id_topico As Long
  id_mensaje_original As Long
  asunto As String * 100
  prioridad As Byte
  fecha_envio As Date
  envio_anonimo As String * 1
  estatus As String * 1
  incluir_original As String * 1
  id_foro As Long
  id_usuario As Long
  nombre_autor As String * 80
  id_emoticon As Long
End Type

Public Type MensajeData
  Buffer As String * 202
End Type

Public Type PerfilUsuarioProps
  id_usuario As Long
  titulo As String * 100
  compania As String * 100
  direccion1 As String * 100
  direccion2 As String * 100
  ciudad As String * 100
  estado As String * 80
  cp As String * 20
  telefono As String * 40
  uri As String * 255
End Type

Public Type PerfilUsuarioData
  Buffer As String * 898
End Type

Public Type SuscripcionProps
  id_usuario As Long
  id_foro As Long
  estatus As String * 1
  enviar_mensajes As String * 1
  email_actualizaciones As String * 1
  email_nuevos As String * 1
  email_anuncios As String * 1
  tipo As String * 1
  fecha_ultima_visita As Date
End Type

Public Type SuscripcionData
  Buffer As String * 14
End Type

Public Type TopicoProps
  id_topico As Long
  id_foro As Long
  nombre As String * 80
  num_respuestas As Long
  fecha_creacion As Date
  fecha_ultimo_mensaje As Date
  id_usuario As Long
End Type

Public Type TopicoData
  Buffer As String * 96
End Type

Public Type UsuarioProps
  id_usuario As Long
  nombre_corto As String * 20
  nombre_completo As String * 80
  password As String * 20
  email As String * 100
  estatus As String * 1
  fecha_registro As Date
  fecha_ultimo_acceso As Date
  administrador As String * 1
End Type

Public Type UsuarioData
  Buffer As String * 234
End Type

Public Type VBMensajeProps
  id_foro As Long
  nombre_foro As String * 20
  id_usuario As Long
  nombre_usuario As String * 20
  id_topico As Long
  nombre_topico As String * 80
  id_mensaje As Long
  asunto As String * 100
  envio_anonimo As String * 1
  nombre_autor As String * 80
  fecha_envio As Date
End Type

Public Type VBMensajeData
  Buffer As String * 314
End Type

Public Type VBTopicoProps
  id_foro As Long
  nombre_foro As String * 20
  id_usuario As Long
  nombre_usuario As String * 20
  id_topico As Long
  nombre_topico As String * 80
  num_respuestas As Long
  fecha_creacion As Date
  fecha_ultimo_mensaje As Date
End Type

Public Type VBTopicoData
  Buffer As String * 136
End Type

Public Type VMensajeProps
  id_mensaje As Long
  id_mensaje_original As Long
  asunto As String * 100
  prioridad As Byte
  fecha_envio As Date
  envio_anonimo As String * 1
  estatus_mensaje As String * 1
  incluir_original As String * 1
  id_usuario As Long
  nombre_usuario As String * 20
  email_usuario As String * 100
  id_emoticon As Long
  nombre_autor As String * 80
  uri_attachment As String * 255
  nombre_topico As String * 80
End Type
  
Public Type VMensajeData
  Buffer As String * 654
End Type

Public Type VSuscripcionProps
  id_usuario As Long
  nombre_corto_usuario As String * 20
  nombre_completo_usuario As String * 80
  email_usuario As String * 100
  id_foro As Long
  estatus As String * 1
  email_actualizaciones As String * 1
  email_nuevos As String * 1
  email_anuncios As String * 1
  tipo As String * 1
  fecha_ultima_visita As Date
  enviar_mensajes As String * 1
End Type
  
Public Type VSuscripcionData
  Buffer As String * 216
End Type

Public Type VTopicoProps
  id_topico As Long
  nombre_topico As String * 80
  num_respuestas As Long
  id_usuario As Long
  nombre_usuario As String * 20
  email_usuario As String * 100
  fecha_creacion As Date
  fecha_ultimo_mensaje As Date
End Type
  
Public Type VTopicoData
  Buffer As String * 214
End Type


