VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 1  'NoTransaction
END
Attribute VB_Name = "TopicoIDGenerator"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements ObjectControl

Private mobjContext As ObjectContext
Private mflgInMTS As Boolean

Public Function getNextID() As Long
  Dim strSQL As String
  Dim rs As New adodb.Recordset
  Dim increment As Long
  Dim max As Long
  Dim currentID As Long
  Dim spmMgr As SharedPropertyGroupManager
  Dim spmGroup As SharedPropertyGroup
  Dim spmPropCurrentID As SharedProperty
  Dim spmPropMax As SharedProperty
  Dim bResult As Boolean
    
  On Error GoTo errhandler
  
  Set spmMgr = CreateObject("MTxSpm.SharedPropertyGroupManager.1")
  Set spmGroup = spmMgr.CreatePropertyGroup("TopicoIDGenerator", LockMethod, Process, bResult)
  Set spmPropCurrentID = spmGroup.CreateProperty("currentID", bResult)
  If Not bResult Then
    spmPropCurrentID.Value = 0
  End If
  currentID = spmPropCurrentID.Value
  Set spmPropMax = spmGroup.CreateProperty("max", bResult)
  If Not bResult Then
    spmPropMax.Value = 0
  End If
  max = spmPropMax.Value
  increment = 1
  currentID = currentID + 1
  If currentID > max Then
    strSQL = "SELECT TABLE_NAME, NEXTIDSET FROM SURROGATES WHERE TABLE_NAME = 'TOPICO'"
    With rs
      .Open strSQL, DBCONNECTION, adOpenKeyset, adLockOptimistic
      currentID = .Fields("NEXTIDSET")
      .Fields("NEXTIDSET") = currentID + increment
      .Update
      .Close
    End With
    Set rs = Nothing
    max = currentID + increment - 1
  End If
  spmPropCurrentID.Value = currentID
  spmPropMax.Value = max
  getNextID = currentID
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "EmoticonIDGenerator [getNextID()]: " & Err.Number & ": " & Err.Description
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Private Sub ObjectControl_Activate()
  Set mobjContext = GetObjectContext
  mflgInMTS = True
End Sub

Private Function ObjectControl_CanBePooled() As Boolean
  ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
  Set mobjContext = Nothing
End Sub

