VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "VTopicoPersist"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements ObjectControl
Private mobjContext As ObjectContext
Private mflgInMTS As Boolean

Public Function getTopicosForo(ByVal id_foro As Long) As String
  Dim rs As adodb.Recordset
  Dim strSQL As String
  Dim udtProps As VTopicoProps
  Dim lngIndex As Long
  Dim PBag As PropertyBag

  On Error GoTo errhandler
  
  Set PBag = New PropertyBag
  strSQL = "Select t1.ID_TOPICO, t1.NOMBRE NOMBRE_TOPICO, t1.NUM_RESPUESTAS, " _
         & "t1.ID_USUARIO, t2.NOMBRE_CORTO NOMBRE_USUARIO, t2.EMAIL EMAIL_USUARIO, " _
         & "t1.FECHA_CREACION, t1.FECHA_ULTIMO_MENSAJE " _
         & "From TOPICO t1, USUARIO t2 " _
         & "Where t1.ID_USUARIO = t2.ID_USUARIO " _
         & "And t1.ID_FORO = " & id_foro & " " _
         & "Order By t1.ID_TOPICO"

  Set rs = New adodb.Recordset
  With rs
    .Open strSQL, DBCONNECTION, adOpenForwardOnly, adLockReadOnly
    While Not .EOF
      lngIndex = lngIndex + 1
      udtProps.id_topico = .Fields("id_topico").Value
      udtProps.id_usuario = .Fields("id_usuario").Value
      udtProps.email_usuario = .Fields("email_usuario").Value & ""
      udtProps.fecha_creacion = .Fields("fecha_creacion").Value
      udtProps.fecha_ultimo_mensaje = Nvl(.Fields("fecha_ultimo_mensaje").Value, 0)
      udtProps.nombre_topico = .Fields("nombre_topico").Value & ""
      udtProps.nombre_usuario = .Fields("nombre_usuario").Value & ""
      udtProps.num_respuestas = .Fields("num_respuestas").Value
      PBag.WriteProperty "Item" & lngIndex, SerializeVTopico(udtProps)
      .MoveNext
    Wend
    .Close
  End With
  Set rs = Nothing
  PBag.WriteProperty "Count", lngIndex
  getTopicosForo = PBag.Contents
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function

errhandler:
  App.LogEvent "VTopicoPersist [getTopicosForo()]: " & Err.Number & ": " & Err.Description
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Private Function DeserializeVTopico(ByVal Buffer As String) As VTopicoProps
  Dim udtData As VTopicoData
  Dim PBag As PropertyBag
  Dim arrbyte_buff() As Byte
  
  arrbyte_buff = Buffer
  Set PBag = New PropertyBag
  With PBag
    .Contents = arrbyte_buff
    udtData.Buffer = .ReadProperty("fixedlength_state")
  End With
  Set PBag = Nothing
  LSet DeserializeVTopico = udtData
End Function

Private Function SerializeVTopico(ByRef udtProps As VTopicoProps) As String
  Dim udtData As VTopicoData
  Dim PBag As PropertyBag
  
  LSet udtData = udtProps
  Set PBag = New PropertyBag
  With PBag
    .WriteProperty "fixedlength_state", udtData.Buffer
    SerializeVTopico = .Contents
  End With
  Set PBag = Nothing
End Function

Private Sub ObjectControl_Activate()
  Set mobjContext = GetObjectContext
  mflgInMTS = True
End Sub

Private Function ObjectControl_CanBePooled() As Boolean
  ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
  Set mobjContext = Nothing
End Sub






