VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MailManDispatch"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements WebForumsAuxLCE.Mailman

Private Function MessageEncode(ByRef mensaje As Object, ByRef layout As String) As String
  Dim part As String
  Dim StrUtil As New StringUtils
  Dim CustFormats As New CustomFormats
  
  part = Replace(layout, "##id_mensaje##", mensaje.id_mensaje)
  part = Replace(part, "##id_mensaje_original#", mensaje.id_mensaje_original)
  part = Replace(part, "##asunto##", mensaje.asunto)
  part = Replace(part, "##contenido##", mensaje.contenido)
  part = Replace(part, "##reply_contenido##", StrUtil.ReplyText(mensaje.contenido))
  part = Replace(part, "##prioridad##", mensaje.prioridad)
  part = Replace(part, "##fecha_envio##", CustFormats.StringDate(mensaje.fecha_envio))
  part = Replace(part, "##envio_anonimo##", mensaje.envio_anonimo)
  part = Replace(part, "##estatus_mensaje##", mensaje.estatus_mensaje)
  part = Replace(part, "##incluir_original##", mensaje.incluir_original)
  part = Replace(part, "##id_usuario##", mensaje.id_usuario)
  part = Replace(part, "##nombre_usuario##", mensaje.nombre_usuario)
  part = Replace(part, "##email_usuario##", mensaje.email_usuario)
  part = Replace(part, "##id_emoticon##", mensaje.id_emoticon)
  part = Replace(part, "##nombre_autor##", mensaje.nombre_autor)
  part = Replace(part, "##uri_attachment##", mensaje.uri_attachment)
  part = Replace(part, "##nombre_topico##", mensaje.nombre_topico)
  MessageEncode = part
End Function

Private Sub Mailman_run(ByVal id_mensaje As Long)
  Dim objSettings As New Settings
  Dim mailmsg_from As String
  Dim mailmsg_organization As String
  Dim iMsg As New CDO.Message
  Dim iConf As New CDO.Configuration
  Dim Flds As ADODB.Fields
  Dim vmensaje As Object
  Dim vmensajedb As Object
  Dim vmensajeorig As Object
  Dim vectusuario As Object
  Dim usuariodb As Object
  Dim original_msg As String
  Dim item As Object
  
  On Error GoTo ErrorHandler
  Set vmensajedb = CreateObject("WebForumsPersist.VMensajePersist")
  Set vmensaje = CreateObject("WebForumsDomain.VMensaje")
  vmensaje.SetState vmensajedb.getMensaje(id_mensaje)
  If UCase(vmensaje.incluir_original) = "S" Then
    Set vmensajeorig = CreateObject("WebForumsDomain.VMensaje")
    vmensajeorig.SetState vmensajedb.getMensaje(vmensaje.id_mensaje_original)
  End If
  Set vmensajedb = Nothing
  Set usuariodb = CreateObject("WebForumsPersist.UsuarioPersist")
  Set vectusuario = CreateObject("WebForumsDomain.VectorUsuario")
  vectusuario.SetState usuariodb.getUsuariosToSendEmail(id_mensaje)
  Set usuariodb = Nothing
  If vectusuario.count > 0 Then
    Set Flds = iConf.Fields
    With Flds
      .item(cdoSendUsingMethod) = cdoSendUsingPort
      .item(cdoSMTPServer) = objSettings.getSetting("mail.smtp.host")
      .item(cdoSMTPConnectionTimeout) = 10 ' quick timeout
      .item(cdoSMTPAuthenticate) = cdoBasic
      .item(cdoSendUserName) = objSettings.getSetting("mail.smtp.user")
      .item(cdoSendPassword) = objSettings.getSetting("mail.smtp.password")
      .item(cdoURLGetLatestVersion) = True
      .Update
    End With
  
    With iMsg
      Set .Configuration = iConf
      .From = objSettings.getSetting("mailmsg.from")
      .ReplyTo = vmensaje.nombre_usuario & " <" & vmensaje.email_usuario & ">"
      '.SentOn = Now
      .Organization = objSettings.getSetting("mailmsg.organization")
      If UCase(vmensaje.incluir_original) = "S" Then
        original_msg = MessageEncode(vmensajeorig, objSettings.getSetting("mailmsg.originalmsg"))
      End If
      If vmensaje.id_mensaje_original > 0 Then
        .Subject = MessageEncode(vmensaje, objSettings.getSetting("mailmsg.newtopic.subject"))
        .TextBody = MessageEncode(vmensaje, objSettings.getSetting("mailmsg.newtopic.body")) & original_msg
      Else
        .Subject = MessageEncode(vmensaje, objSettings.getSetting("mailmsg.reply.subject"))
        .TextBody = MessageEncode(vmensaje, objSettings.getSetting("mailmsg.reply.body")) & original_msg
      End If
      For Each item In vectusuario
        .To = item.email
        .Send
      Next item
      .Send
    End With
  End If
  Set vmensaje = Nothing
  Set vmensajeorig = Nothing
  Set vectusuario = Nothing
  Exit Sub
  
ErrorHandler:
  Set vmensaje = Nothing
  Set vmensajeorig = Nothing
  Set vectusuario = Nothing
  App.LogEvent "MailManDispatch [run()]: Error sending the mail (id_mensaje=" & _
    id_mensaje & ") [" & Err.Number & "] " & Err.Description
End Sub
'
'Public Sub test(ByVal id_mensaje As Long)
'  Mailman_run id_mensaje
'End Sub
