VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "StringUtils"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Function JavaEncode(stInput As String) As String
  Dim filtered As String
  Dim i As Integer
  For i = 1 To Len(stInput)
    Select Case Asc(Mid(stInput, i, 1))
      Case 8: filtered = filtered & "\b"
      Case 12: filtered = filtered & "\f"
      Case 10: filtered = filtered & "\n"
      Case 13: filtered = filtered & "\r"
      Case 9: filtered = filtered & "\t"
      Case 39: filtered = filtered & "\'"
      Case 34: filtered = filtered & "\"""
      Case 92: filtered = filtered & "\\"
      Case Else: filtered = filtered & Mid(stInput, i, 1)
    End Select
  Next i
  JavaEncode = filtered
End Function

Public Function URLItemEncode(stInput As String) As String
  Dim filtered As String
  Dim i As Integer
  For i = 1 To Len(stInput)
    Select Case Mid(stInput, i, 1)
      Case " ": filtered = filtered & "%20"
      Case "&": filtered = filtered & "%26"
      Case "%": filtered = filtered & "%23"
      'Case """": filtered = filtered & "%22"
      Case ";": filtered = filtered & "%3B"
      Case ":": filtered = filtered & "%3A"
      'Case "'": filtered = filtered & "%27"
      Case "%": filtered = filtered & "%25"
      Case "?": filtered = filtered & "%2C"
      Case "_": filtered = filtered & "%5F"
      Case Else: filtered = filtered & Mid(stInput, i, 1)
    End Select
  Next i
  URLItemEncode = filtered
End Function

Public Function validAttahcmentName(name As String) As String
  Dim filtered As String
  Dim i As Integer
  For i = 1 To Len(name)
    Select Case Asc(Mid(name, i, 1))
      Case 32: filtered = filtered & "%20"
      Case 37: filtered = filtered & "%25"
      Case Else: filtered = filtered & Mid(name, i, 1)
    End Select
  Next i
  validAttahcmentName = filtered
End Function

Public Function HTMLBreakLines(stInput As String) As String
  HTMLBreakLines = Replace(stInput, vbCrLf, "<BR>")
End Function

Public Function ReplyText(stInput As String) As String
  ReplyText = ">" & Replace(stInput, vbCrLf, vbCrLf & ">")
End Function
