VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "NavItemsVector"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements ObjectControl

Public Sub addNavButton(cmdKey As String, image As String, hint As String, text As String, roles As String, commands As String)
  Dim spmMgr As SharedPropertyGroupManager
  Dim spmGroup As SharedPropertyGroup
  Dim spmProp As SharedProperty
  Dim bResult As Boolean
  Dim vArrAux As Variant
  Dim vItmAux As Variant
  Dim sValAux As String
  
  Set spmMgr = CreateObject("MTxSpm.SharedPropertyGroupManager.1")
  Set spmGroup = spmMgr.CreatePropertyGroup("Items", LockSetGet, Process, bResult)
  Set spmProp = spmGroup.CreateProperty("All", bResult)
  If bResult Then
    sValAux = ""
    vArrAux = Split(spmProp.Value, ",")
    For Each vItmAux In vArrAux
      If vItmAux <> cmdKey Then sValAux = sValAux & "," & vItmAux
    Next vItmAux
    sValAux = sValAux & "," & cmdKey
    sValAux = Right(sValAux, Len(sValAux) - 1)
    spmProp.Value = sValAux
  Else
    spmProp.Value = cmdKey
  End If
  Set spmProp = Nothing
  Set spmGroup = spmMgr.CreatePropertyGroup("Roles", LockSetGet, Process, bResult)
  Set spmProp = spmGroup.CreateProperty(cmdKey, bResult)
  spmProp.Value = roles
  Set spmProp = Nothing
  Set spmGroup = spmMgr.CreatePropertyGroup("Commands", LockSetGet, Process, bResult)
  Set spmProp = spmGroup.CreateProperty(cmdKey, bResult)
  spmProp.Value = commands
  Set spmProp = Nothing
  Set spmGroup = spmMgr.CreatePropertyGroup("Html", LockSetGet, Process, bResult)
  Set spmProp = spmGroup.CreateProperty(cmdKey, bResult)
  spmProp.Value = "writeToolButton('" & cmdKey & "','" & text & "','" & hint & "','" & image & "');" & vbCrLf
  Set spmProp = Nothing
  Set spmGroup = Nothing
  Set spmMgr = Nothing
End Sub

Private Function rebuildComboHTML(cmdKey As String, paramName As String, hint As String, text As String, provider As String) As String
  Dim hasPrevious As Boolean
  Dim cat() As Catalog
  Dim itm As Variant
  Dim objContext As COMSVCSLib.ObjectContext
  Dim objServer As ASPTypeLibrary.Server
  Dim objProvider As ICatalogProvider
  Dim sHtml As String
  
  Set objContext = GetObjectContext
  Set objServer = objContext("Server")
  Set objProvider = CreateObject("WebForumsView." & provider)
  cat = objProvider.Catalog
  Set objProvider = Nothing
  
  hasPrevious = False
  sHtml = "writeToolCombo('" & cmdKey & "','" & text & "','" & _
            hint & "','" & paramName & "',new Array("
  For Each itm In cat
    If hasPrevious Then
      sHtml = sHtml & ","
    Else
      hasPrevious = True
    End If
    sHtml = sHtml & "new Array('" & objServer.HTMLEncode(itm.Identifier) & _
              "','" & objServer.HTMLEncode(itm.Name) & "')"
  Next
  sHtml = sHtml & "));" & vbCrLf
  rebuildComboHTML = sHtml
End Function

Public Sub addNavComboBox(cmdKey As String, paramName As String, hint As String, text As String, provider As String, roles As String, commands As String)
  Dim spmMgr As SharedPropertyGroupManager
  Dim spmGroup As SharedPropertyGroup
  Dim spmProp As SharedProperty
  Dim bResult As Boolean
  Dim vArrAux As Variant
  Dim vItmAux As Variant
  Dim sValAux As String
  
  Set spmMgr = CreateObject("MTxSpm.SharedPropertyGroupManager.1")
  Set spmGroup = spmMgr.CreatePropertyGroup("Items", LockSetGet, Process, bResult)
  Set spmProp = spmGroup.CreateProperty("All", bResult)
  If bResult Then
    sValAux = ""
    vArrAux = Split(spmProp.Value, ",")
    For Each vItmAux In vArrAux
      If vItmAux <> cmdKey Then sValAux = sValAux & "," & vItmAux
    Next vItmAux
    sValAux = sValAux & "," & cmdKey
    sValAux = Right(sValAux, Len(sValAux) - 1)
    spmProp.Value = sValAux
  Else
    spmProp.Value = cmdKey
  End If
  Set spmProp = spmGroup.CreateProperty("Combos", bResult)
  If bResult Then
    sValAux = ""
    vArrAux = Split(spmProp.Value, ",")
    For Each vItmAux In vArrAux
      If vItmAux <> cmdKey Then sValAux = sValAux & "," & vItmAux
    Next vItmAux
    sValAux = sValAux & "," & cmdKey
    sValAux = Right(sValAux, Len(sValAux) - 1)
    spmProp.Value = sValAux
  Else
    spmProp.Value = cmdKey
  End If
  Set spmProp = Nothing
  Set spmGroup = spmMgr.CreatePropertyGroup("Roles", LockSetGet, Process, bResult)
  Set spmProp = spmGroup.CreateProperty(cmdKey, bResult)
  spmProp.Value = roles
  Set spmProp = Nothing
  Set spmGroup = spmMgr.CreatePropertyGroup("Commands", LockSetGet, Process, bResult)
  Set spmProp = spmGroup.CreateProperty(cmdKey, bResult)
  spmProp.Value = commands
  Set spmProp = Nothing
  Set spmGroup = spmMgr.CreatePropertyGroup("RebuildParams", LockSetGet, Process, bResult)
  Set spmProp = spmGroup.CreateProperty(cmdKey, bResult)
  spmProp.Value = paramName & "," & hint & "," & text & "," & provider
  Set spmProp = Nothing
  Set spmGroup = Nothing
  sValAux = rebuildComboHTML(cmdKey, paramName, hint, text, provider)
  Set spmGroup = spmMgr.CreatePropertyGroup("Html", LockSetGet, Process, bResult)
  Set spmProp = spmGroup.CreateProperty(cmdKey, bResult)
  spmProp.Value = sValAux
  Set spmProp = Nothing
  Set spmGroup = Nothing
  Set spmMgr = Nothing
End Sub

Public Function getHTML(rol As String, cmdKey As String) As String
  Dim spmMgr As SharedPropertyGroupManager
  Dim spmGroupItems As SharedPropertyGroup
  Dim spmGroupHtml As SharedPropertyGroup
  Dim spmGroupRoles As SharedPropertyGroup
  Dim spmGroupCommands As SharedPropertyGroup
  Dim spmProp As SharedProperty
  Dim bResult As Boolean
  Dim vArrAux As Variant
  Dim vItmAux As Variant
  Dim codeHTML As String
  Dim sValAux As String
  
  Set spmMgr = CreateObject("MTxSpm.SharedPropertyGroupManager.1")
  Set spmGroupItems = spmMgr.CreatePropertyGroup("Items", LockSetGet, Process, bResult)
  Set spmProp = spmGroupItems.CreateProperty("All", bResult)
  sValAux = spmProp.Value
  Set spmProp = Nothing
  Set spmGroupItems = Nothing
  
  If bResult Then
    codeHTML = "<SCRIPT language=""javascript"">" & vbCrLf & "<!--" & vbCrLf & _
               "writeToolbarStart();" & vbCrLf
    vArrAux = Split(sValAux, ",")
    Set spmGroupRoles = spmMgr.CreatePropertyGroup("Roles", LockSetGet, Process, bResult)
    Set spmGroupCommands = spmMgr.CreatePropertyGroup("Commands", LockSetGet, Process, bResult)
    Set spmGroupHtml = spmMgr.CreatePropertyGroup("Html", LockSetGet, Process, bResult)
    For Each vItmAux In vArrAux
      Set spmProp = spmGroupRoles.CreateProperty(CStr(vItmAux), bResult)
      sValAux = spmProp.Value
      Set spmProp = Nothing
      If bResult And Len(sValAux) > 0 And InStr(1, sValAux & ",", rol & ",", vbTextCompare) > 0 Then
        Set spmProp = spmGroupCommands.CreateProperty(CStr(vItmAux), bResult)
        sValAux = spmProp.Value
        Set spmProp = Nothing
        If bResult And Len(sValAux) > 0 And InStr(1, sValAux & ",", cmdKey & ",", vbTextCompare) > 0 Then _
          ' Si debe de ir el item
          Set spmProp = spmGroupHtml.CreateProperty(CStr(vItmAux), bResult)
          codeHTML = codeHTML & spmProp.Value
          Set spmProp = Nothing
        End If
      End If
    Next vItmAux
    Set spmGroupRoles = Nothing
    Set spmGroupCommands = Nothing
    Set spmGroupHtml = Nothing
    codeHTML = codeHTML & "writeToolbarEnd();" & vbCrLf & "//-->" & vbCrLf & "</SCRIPT>"
  End If
  getHTML = codeHTML
End Function

Public Sub rebuildHTML()
  Dim spmMgr As SharedPropertyGroupManager
  Dim spmGroupItems As SharedPropertyGroup
  Dim spmGroupHtml As SharedPropertyGroup
  Dim spmGroupRebuildPar As SharedPropertyGroup
  Dim spmProp As SharedProperty
  Dim bResult As Boolean
  Dim vArrAux As Variant
  Dim vItmAux As Variant
  Dim sValAux As String
  Dim iStart, iEnd As Integer
  Dim cmdKey As String
  Dim paramName As String
  Dim hint As String
  Dim text As String
  Dim provider As String
  
  Set spmMgr = CreateObject("MTxSpm.SharedPropertyGroupManager.1")
  Set spmGroupItems = spmMgr.CreatePropertyGroup("Items", LockSetGet, Process, bResult)
  Set spmProp = spmGroupItems.CreateProperty("Combos", bResult)
  sValAux = spmProp.Value
  Set spmProp = Nothing
  Set spmGroupItems = Nothing
  
  If bResult Then
    vArrAux = Split(sValAux, ",")
    Set spmGroupRebuildPar = spmMgr.CreatePropertyGroup("RebuildParams", LockSetGet, Process, bResult)
    Set spmGroupHtml = spmMgr.CreatePropertyGroup("Html", LockSetGet, Process, bResult)
    For Each vItmAux In vArrAux
      Set spmProp = spmGroupRebuildPar.CreateProperty(CStr(vItmAux), bResult)
      sValAux = spmProp.Value
      Set spmProp = Nothing
      iStart = 1
      iEnd = InStr(iStart, sValAux, ",")
      paramName = Mid(sValAux, iStart, iEnd)
      iStart = iEnd + 1
      iEnd = InStr(iStart, sValAux, ",")
      hint = Mid(sValAux, iStart, iEnd)
      iStart = iEnd + 1
      iEnd = InStr(iStart, sValAux, ",")
      text = Mid(sValAux, iStart, iEnd)
      iStart = iEnd + 1
      iEnd = Len(sValAux)
      provider = Mid(sValAux, iStart, iEnd)
      sValAux = rebuildComboHTML(CStr(vItmAux), paramName, hint, text, provider)
      Set spmProp = spmGroupHtml.CreateProperty(CStr(vItmAux), bResult)
      spmProp.Value = sValAux
      Set spmProp = Nothing
    Next vItmAux
    Set spmGroupRebuildPar = Nothing
    Set spmGroupHtml = Nothing
  End If
End Sub

Private Sub ObjectControl_Activate()
End Sub

Private Function ObjectControl_CanBePooled() As Boolean
  ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
End Sub
