// Copyright (c) 2001 NetApplications
package com.netapplications.webforums_jsp.control;

import javax.servlet.*;
import javax.servlet.http.*;

public abstract class Command {
  public abstract String execute(HttpServletRequest req)
    throws CommandException;
  public String execute(HttpServletRequest req, HttpServletResponse res)
    throws CommandException {
    return this.execute(req);
  }
  public boolean globalObjectUpdated() {
    return false;
  }
}
