// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.control;

import javax.servlet.*;
import javax.servlet.http.*;

public class EndSessionCommand extends Command {

  private String next;

  public EndSessionCommand(String next) {
    this.next = next;
  }

  public String execute(HttpServletRequest req) {
    HttpSession session = req.getSession(true);
    if (session.getAttribute("usuario")!=null) {
      session.removeAttribute("usuario");
    }
    session.setAttribute("role", Roles.NOT_LOGGED);
    return next;
  }
}
