// Copyright (c) 2001 NetApplications
package com.netapplications.webforums_jsp.domain;

import java.util.Date;
import java.io.Serializable;

public class Topico extends Object implements Serializable {
  private int id_topico;
  private int id_foro;
  private String nombre;
  private int num_respuestas;
  private int id_usuario;
  private Date fecha_creacion;
  private Date fecha_ultimo_mensaje;


  public Topico() {
    id_topico = 0;
    id_foro = 0;
    nombre = "";
    num_respuestas = 0;
    id_usuario = 0;
    fecha_creacion = new Date();
    fecha_ultimo_mensaje = new Date();
  }

  public synchronized int getId_topico() {
    return id_topico;
  }

  public synchronized void setId_topico(int newId_topico) {
    id_topico = newId_topico;
  }

  public synchronized int getId_foro() {
    return id_foro;
  }

  public synchronized void setId_foro(int newId_foro) {
    id_foro = newId_foro;
  }

  public synchronized String getNombre() {
    return nombre;
  }

  public synchronized void setNombre(String newNombre) {
    nombre = newNombre;
  }

  public synchronized int getNum_respuestas() {
    return num_respuestas;
  }

  public synchronized void setNum_respuestas(int newNum_respuestas) {
    num_respuestas = newNum_respuestas;
  }

  public synchronized int getId_usuario() {
    return id_usuario;
  }

  public synchronized void setId_usuario(int newId_usuario) {
    id_usuario = newId_usuario;
  }

  public synchronized Date getFecha_creacion() {
    return fecha_creacion;
  }

  public synchronized void setFecha_creacion(Date newFecha_creacion) {
    fecha_creacion = newFecha_creacion;
  }

  public synchronized Date getFecha_ultimo_mensaje() {
    return fecha_ultimo_mensaje;
  }

  public synchronized void setFecha_ultimo_mensaje(Date newFecha_ultimo_mensaje) {
    fecha_ultimo_mensaje = newFecha_ultimo_mensaje;
  }
}

