// Copyright (c) 2001 NetApplications
package com.netapplications.webforums_jsp.domain;

import java.util.Date;
import java.io.Serializable;

public class VistaBusquedaTopico extends Object implements Serializable {
  private int id_foro;
  private String nombre_foro;
  private int id_usuario;
  private String nombre_usuario;
  private int id_topico;
  private String nombre_topico;
  private int num_respuestas;
  private Date fecha_creacion;
  private Date fecha_ultimo_mensaje;

  public VistaBusquedaTopico() {
    id_foro = 0;
    nombre_foro = "";
    id_usuario = 0;
    nombre_usuario = "";
    id_topico = 0;
    nombre_topico = "";
    num_respuestas = 0;
    fecha_creacion = new Date();
    fecha_ultimo_mensaje = new Date();
  }

  public synchronized int getId_foro() {
    return id_foro;
  }

  public synchronized void setId_foro(int newId_foro) {
    id_foro = newId_foro;
  }

  public synchronized String getNombre_foro() {
    return nombre_foro;
  }

  public synchronized void setNombre_foro(String newNombre_foro) {
    nombre_foro = newNombre_foro;
  }

  public synchronized int getId_usuario() {
    return id_usuario;
  }

  public synchronized void setId_usuario(int newId_usuario) {
    id_usuario = newId_usuario;
  }

  public synchronized String getNombre_usuario() {
    return nombre_usuario;
  }

  public synchronized void setNombre_usuario(String newNombre_usuario) {
    nombre_usuario = newNombre_usuario;
  }

  public synchronized int getId_topico() {
    return id_topico;
  }

  public synchronized void setId_topico(int newId_topico) {
    id_topico = newId_topico;
  }

  public synchronized String getNombre_topico() {
    return nombre_topico;
  }

  public synchronized void setNombre_topico(String newNombre_topico) {
    nombre_topico = newNombre_topico;
  }

  public synchronized int getNum_respuestas() {
    return num_respuestas;
  }

  public synchronized void setNum_respuestas(int newNum_respuestas) {
    num_respuestas = newNum_respuestas;
  }

  public synchronized Date getFecha_creacion() {
    return fecha_creacion;
  }

  public synchronized void setFecha_creacion(Date newFecha_creacion) {
    fecha_creacion = newFecha_creacion;
  }

  public synchronized Date getFecha_ultimo_mensaje() {
    return fecha_ultimo_mensaje;
  }

  public synchronized void setFecha_ultimo_mensaje(Date newFecha_ultimo_mensaje) {
    fecha_ultimo_mensaje = newFecha_ultimo_mensaje;
  }
}
