// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.servlets;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

class ParseMultiForm extends java.lang.Object {
  private ServletInputStream In;
  private byte buffer[] = new byte[4096];
  private String delimitor = null;
  private String filename=null;

  public ParseMultiForm( ServletRequest _req ) throws IOException{
    In  = _req.getInputStream();
    delimitor   = _req.getContentType();
    if ( delimitor.indexOf("boundary=") != -1 ){
      delimitor = delimitor.substring( delimitor.indexOf("boundary=")+9, delimitor.length() );
      delimitor = "--" + delimitor;
    }
  }

  private String readLine(){
    try{
      int noData = In.readLine( buffer, 0, buffer.length );
      if ( noData != -1 )
        return new String( buffer, 0, noData, "ISO-8859-1");
    }catch(Exception E){}
    return null;
  }

  void test() throws IOException{
    String LineIn;
    while( (LineIn=readLine()) != null )
      System.out.println( LineIn  );
  }

  public String getFilename(){
    return filename;
  }


  public String getNextParameter() {
    try{
      String LineIn=null, paramName=null;

      while ( (LineIn=readLine()) != null ){
        if ( LineIn.indexOf( "name=" ) != -1 ){
          int c1 = LineIn.indexOf( "name=" );
          int c2 = LineIn.indexOf( "\"", c1+6 );
          paramName = LineIn.substring( c1+6, c2 );

          if ( LineIn.indexOf( "filename=") != -1 ){
            c1 = LineIn.indexOf( "filename=" );
            c2 = LineIn.indexOf( "\"", c1+10 );
            filename = LineIn.substring( c1+10, c2 );
            if ( filename.lastIndexOf( "\\" ) != -1 )
              filename = filename.substring( filename.lastIndexOf( "\\" )+1 );

            if ( filename.length() == 0 )
              filename = null;
          }

          //- Move the pointer to the start of the data
          LineIn = readLine();
          if ( LineIn.indexOf( "Content-Type" ) != -1 )
            LineIn = readLine();

          return paramName;
        }
      }
    }
    catch( Exception E ){}
    return null;
  }

  public boolean getParameter( OutputStream _Out ){
    try{
        int noData;
        while ( (noData=In.readLine(buffer,0,buffer.length)) != -1 ){
          if ( buffer[0] == '-' ){
            if ( new String( buffer, 0, noData, "ISO-8859-1").indexOf(delimitor) == 0 )
              break;
          }else
            _Out.write( buffer, 0, noData );
        }

        _Out.flush();
      return true;
    }
    catch( Exception E ){
      System.out.println( E  );
    }
    return false;
  }

  public String getParameter(boolean multiLine){
    if (!multiLine) {
      String retVal = readLine();
      return (retVal.endsWith("\r\n"))?retVal.substring(0, retVal.length()-2):retVal;
    } else {
      try{
        StringBuffer _Out = new StringBuffer(100);
        int noData;
        while ( (noData=In.readLine(buffer,0,buffer.length)) != -1 ){
          if ( buffer[0] == '-' ){
            if ( new String( buffer, 0, noData, "ISO-8859-1").indexOf(delimitor) == 0 ) {
              break;
            }
          } else {
            _Out.append(new String( buffer, 0, noData, "ISO-8859-1"));
          }
        }
        return (_Out.charAt(_Out.length()-2)=='\r'&&_Out.charAt(_Out.length()-1)=='\n')
          ?_Out.delete(_Out.length()-2,_Out.length()-1).toString():_Out.toString();
      } catch( Exception E ){
        System.out.println( E  );
        return "";
      }
    }
  }

  public String getParameter() {
    return this.getParameter(false);
  }
}
