// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.view;

import  com.netapplications.webforums_jsp.util.StringUtils;
import java.io.Serializable;

public class NavButton extends Object implements Serializable, INavItem {

  private String cmdKey;
  private String image;
  private String hint;
  private String text;
  private String strHTML;

  public NavButton(String cmdKey, String image, String hint, String text)
      throws IllegalArgumentException {
    if (cmdKey!=null && image!=null && hint!=null && text!=null) {
      this.cmdKey = cmdKey;
      this.image = image;
      this.hint = hint;
      this.text = text;
      this.strHTML = "writeToolButton(\'"+cmdKey+"\',\'"+text+"\',\'"+hint+"\',\'"+image+"\');\r\n";
/*
      StringBuffer strbufHTML = new StringBuffer(40);
      strbufHTML.append("<A href=\"javascript:nav_click(\'");
      strbufHTML.append(cmdKey);
      strbufHTML.append("\')\" onMouseOver=\"top.status=\'");
      strbufHTML.append(StringUtils.JavaEncode(hint));
      strbufHTML.append("\'; return true;\" onMouseOut=\"top.status=\'\';\">");
      strbufHTML.append("<DIV class=\"ButtonsNav\"><IMG src=\"images/");
      strbufHTML.append(image);
      strbufHTML.append("\" border=\"0\" alt=\"");
      strbufHTML.append(hint);
      strbufHTML.append("\">&nbsp;");
      strbufHTML.append(StringUtils.HTMLEncode(text));
      strbufHTML.append("</DIV></A>");
      strHTML = strbufHTML.toString();
*/      
    } else {
      throw new IllegalArgumentException("All arguments of this constructor are mandatory");
    }
  }

// this item has static content
  public synchronized void rebuildHTML() {}

  public String getHTML() {
    return strHTML;
  }
}

