VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "UsuarioPersist"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Implements ObjectControl

Private mobjContext As ObjectContext
Private mflgInMTS As Boolean

Public Function getUsuario(ByVal id_usuario As Long) As String
Dim rs As New adodb.Recordset
Dim strSQL As String
Dim udtProps As UsuarioProps

  On Error GoTo errhandler
  
  strSQL = "SELECT * FROM USUARIO WHERE ID_USUARIO = " & id_usuario
  rs.Open strSQL, DBCONNECTION, adOpenForwardOnly, adLockReadOnly
  With udtProps
    .id_usuario = id_usuario
    .nombre_corto = rs!nombre_corto & ""
    .nombre_completo = rs!nombre_completo & ""
    .password = rs!password & ""
    .email = rs!email & ""
    .estatus = rs!estatus & ""
    .fecha_registro = rs!fecha_registro
    .fecha_ultimo_acceso = rs!fecha_ultimo_acceso
    .administrador = rs!administrador & ""
  End With
  rs.Close
  Set rs = Nothing
  getUsuario = SerializeUsuario(udtProps)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "UsuarioPersist [getUsuario()]: " & Err.Number & ": " & Err.Description & " (id_usuario=" & id_usuario & ")"
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function getUsuarioLogin(ByVal nombre_corto As String, ByVal password As String) As String
  Dim cn As New adodb.Connection
  Dim cm As New adodb.Command
  Dim rs As New adodb.Recordset
  Dim strSQL As String
  Dim udtProps As UsuarioProps
  
  On Error GoTo errhandler
  
  strSQL = "SELECT * FROM USUARIO WHERE NOMBRE_CORTO = ? AND PASSWORD = ?"
  cn.ConnectionString = DBCONNECTION
  cn.CursorLocation = adUseClient
  cn.Open
  cm.ActiveConnection = cn
  cm.CommandType = adCmdText
  cm.CommandText = strSQL
  cm.Parameters(0).Value = nombre_corto
  cm.Parameters(1).Value = password
  rs.CursorLocation = adUseClient
  rs.LockType = adLockReadOnly
  rs.CursorType = adOpenStatic
  Set rs = cm.Execute
  Set rs.ActiveConnection = Nothing
  cn.Close
  Set cm = Nothing
  Set cn = Nothing
  With rs
    If .EOF Then
      .Close
      Err.Raise vbObjectError + 1001, , "No se encontro el Usuario : " & nombre_corto & "  la contrasea es invlida"
    Else
      udtProps.id_usuario = .Fields("id_usuario").Value
      udtProps.nombre_corto = .Fields("nombre_corto").Value & ""
      udtProps.nombre_completo = .Fields("nombre_completo").Value & ""
      udtProps.password = .Fields("password").Value & ""
      udtProps.email = .Fields("email").Value & ""
      udtProps.estatus = .Fields("estatus").Value & ""
      udtProps.fecha_registro = .Fields("fecha_registro").Value
      udtProps.fecha_ultimo_acceso = .Fields("fecha_ultimo_acceso").Value
      udtProps.administrador = .Fields("administrador").Value & ""
      .Close
    End If
  End With
  Set rs = Nothing
  getUsuarioLogin = SerializeUsuario(udtProps)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "UsuarioPersist [getUsuarioLogin()]: " & Err.Number & ": " & Err.Description
  Set cm = Nothing
  Set cn = Nothing
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function getUsuariosToSendEmail(ByVal id_mensaje As Long) As String
  Dim rs As New adodb.Recordset
  Dim strSQL As String
  Dim udtProps As UsuarioProps
  Dim lngIndex As Long
  Dim PBag As PropertyBag

  On Error GoTo errhandler
  
  Set PBag = New PropertyBag
  strSQL = "SELECT T1.* FROM USUARIO T1, SUSCRIPCION T2, TOPICO T3, MENSAJE T4 " _
    & "WHERE T1.ID_USUARIO = T2.ID_USUARIO AND T2.ID_FORO = T3.ID_FORO " _
    & "AND T3.ID_TOPICO = T4.ID_TOPICO AND T2.ESTATUS = 'A' " _
    & "AND T2.ENVIAR_MENSAJES = 'S' AND (T2.EMAIL_ACTUALIZACIONES = 'S' " _
    & "OR (T2.EMAIL_NUEVOS = 'S' AND T4.ID_MENSAJE_ORIGINAL IS NULL)) " _
    & "AND T4.ID_MENSAJE = " & id_mensaje
  rs.Open strSQL, DBCONNECTION, adOpenForwardOnly, adLockReadOnly
  With rs
    While Not .EOF
      lngIndex = lngIndex + 1
      udtProps.id_usuario = .Fields("id_usuario").Value
      udtProps.nombre_corto = .Fields("nombre_corto").Value & ""
      udtProps.nombre_completo = .Fields("nombre_completo").Value & ""
      udtProps.password = .Fields("password").Value & ""
      udtProps.email = .Fields("email").Value & ""
      udtProps.estatus = .Fields("estatus").Value & ""
      udtProps.fecha_registro = .Fields("fecha_registro").Value
      udtProps.fecha_ultimo_acceso = .Fields("fecha_ultimo_acceso").Value
      udtProps.administrador = .Fields("administrador").Value & ""
      PBag.WriteProperty "Item" & lngIndex, SerializeUsuario(udtProps)
      .MoveNext
    Wend
    .Close
  End With
  Set rs = Nothing
  PBag.WriteProperty "Count", lngIndex
  getUsuariosToSendEmail = PBag.Contents
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function

errhandler:
  App.LogEvent "UsuarioPersist [getUsuariosToSendEmail()]: " & Err.Number & ": " & Err.Description & " (id_mensaje=" & id_mensaje & ")"
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function updateUsuario(ByVal Buffer As String) As String
  Dim udtProps As UsuarioProps
  
  On Error GoTo errhandler
  
  udtProps = DeserializeUsuario(Buffer)
  updateUsuario = saveUsuario(udtProps, False)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "UsuarioPersist [updateUsuario()]: " & Err.Number & ": " & Err.Description & " (id_usuario=" & udtProps.id_usuario & ")"
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function putUsuario(ByVal Buffer As String) As String
  Dim udtProps As UsuarioProps
  
  On Error GoTo errhandler
  
  udtProps = DeserializeUsuario(Buffer)
  putUsuario = saveUsuario(udtProps, True)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function
  
errhandler:
  App.LogEvent "UsuarioPersist [putUsuario()]: " & Err.Number & ": " & Err.Description
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Private Function saveUsuario(ByRef udtProps As UsuarioProps, ByVal isNew As Boolean) As String
Dim rs As New adodb.Recordset
Dim strSQL As String

  On Error GoTo errhandler

  strSQL = "SELECT * FROM USUARIO WHERE ID_USUARIO = " & udtProps.id_usuario
  rs.Open strSQL, DBCONNECTION, adOpenKeyset, adLockOptimistic
  With udtProps
    If isNew Then
      Dim UsuaIDGen As UsuarioIDGenerator
      If mflgInMTS Then
        Set UsuaIDGen = mobjContext.CreateInstance("WebForumsPersist.UsuarioIDGenerator")
      Else
        Set UsuaIDGen = CreateObject("WebForumsPersist.UsuarioIDGenerator")
      End If
      rs.AddNew
      .id_usuario = UsuaIDGen.getNextID
      Set UsuaIDGen = Nothing
      .fecha_registro = Now
    End If
    rs!id_usuario = .id_usuario
    rs!nombre_corto = Trim$(.nombre_corto)
    rs!nombre_completo = Trim$(.nombre_completo)
    rs!password = Trim$(.password)
    rs!email = Trim$(.email)
    rs!estatus = .estatus
    rs!fecha_registro = .fecha_registro
    rs!fecha_ultimo_acceso = .fecha_ultimo_acceso
    rs!administrador = .administrador
  End With
  rs.Update
  rs.Close
  Set rs = Nothing
  saveUsuario = SerializeUsuario(udtProps)
  Exit Function

errhandler:
  Set rs = Nothing
  Err.Raise Err.Number
End Function

Public Sub removeUsuario(ByVal id_usuario As Long)
Dim cn As adodb.Connection
Dim strSQL As String
  
  On Error GoTo errhandler
  
  Set cn = New adodb.Connection
  With cn
    .Open DBCONNECTION
    strSQL = "DELETE USUARIO WHERE ID_USUARIO = " & id_usuario
    .Execute strSQL
    .Close
  End With
  cn.Close
  Set cn = Nothing
  If mflgInMTS Then mobjContext.SetComplete
  Exit Sub
  
errhandler:
  App.LogEvent "UsuarioPersist [removeUsuario()]: " & Err.Number & ": " & Err.Description & " (id_usuario=" & id_usuario & ")"
  Set cn = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Sub

Private Function DeserializeUsuario(ByVal Buffer As String) As UsuarioProps
  Dim udtData As UsuarioData
  Dim PBag As PropertyBag
  Dim arrbyte_buff() As Byte
  
  arrbyte_buff = Buffer
  Set PBag = New PropertyBag
  With PBag
    .Contents = arrbyte_buff
    udtData.Buffer = .ReadProperty("fixedlength_state")
  End With
  Set PBag = Nothing
  LSet DeserializeUsuario = udtData
End Function

Private Function SerializeUsuario(ByRef udtProps As UsuarioProps) As String
  Dim udtData As UsuarioData
  Dim PBag As PropertyBag
  
  LSet udtData = udtProps
  Set PBag = New PropertyBag
  With PBag
    .WriteProperty "fixedlength_state", udtData.Buffer
    SerializeUsuario = .Contents
  End With
  Set PBag = Nothing
End Function

Private Sub ObjectControl_Activate()
  Set mobjContext = GetObjectContext
  mflgInMTS = True
End Sub

Private Function ObjectControl_CanBePooled() As Boolean
  ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
  Set mobjContext = Nothing
End Sub

