VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 3  'UsesTransaction
END
Attribute VB_Name = "VMensajePersist"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements ObjectControl
Private mobjContext As ObjectContext
Private mflgInMTS As Boolean

Public Function getMensajesTopico(ByVal id_topico As Long) As String
  Dim rs As adodb.Recordset
  Dim strSQL As String
  Dim udtProps As VMensajeProps
  Dim lngIndex As Long
  Dim PBag As PropertyBag
  Dim contenido As String

  On Error GoTo errhandler
  
  Set PBag = New PropertyBag
  strSQL = "Select t1.ID_MENSAJE, t1.ID_MENSAJE_ORIGINAL, t1.ID_USUARIO, " _
         & "t1.ASUNTO, t1.CONTENIDO, t1.INCLUIR_ORIGINAL, t1.PRIORIDAD, " _
         & "t1.FECHA_ENVIO, t1.ENVIO_ANONIMO, t1.ESTATUS ESTATUS_MENSAJE, " _
         & "t2.NOMBRE_CORTO NOMBRE_USUARIO, t2.EMAIL EMAIL_USUARIO, " _
         & "t1.ID_EMOTICON, t1.NOMBRE_AUTOR, t3.URI URI_ATTACHMENT, " _
         & "t4.NOMBRE NOMBRE_TOPICO " _
         & "From MENSAJE t1 INNER JOIN USUARIO t2 ON t1.ID_USUARIO = t2.ID_USUARIO " _
         & "INNER JOIN TOPICO t4 ON t1.ID_TOPICO = t4.ID_TOPICO " _
         & "LEFT OUTER JOIN ATTACHMENT t3 ON t1.ID_MENSAJE = t3.ID_MENSAJE " _
         & "Where t1.ID_TOPICO = " & id_topico & " " _
         & "Order By t1.ID_MENSAJE"

  Set rs = New adodb.Recordset
  With rs
    .Open strSQL, DBCONNECTION, adOpenForwardOnly, adLockReadOnly
    While Not .EOF
      lngIndex = lngIndex + 1
      udtProps.id_mensaje = .Fields("id_mensaje").Value
      udtProps.id_mensaje_original = Nvl(.Fields("id_mensaje_original").Value, 0)
      udtProps.id_emoticon = Nvl(.Fields("id_emoticon").Value, 0)
      udtProps.id_usuario = .Fields("id_usuario").Value
      udtProps.asunto = .Fields("asunto").Value & ""
      udtProps.email_usuario = .Fields("email_usuario").Value & ""
      udtProps.estatus_mensaje = .Fields("estatus_mensaje").Value & ""
      udtProps.incluir_original = .Fields("incluir_original").Value & ""
      udtProps.prioridad = Nvl(.Fields("prioridad").Value, 0)
      udtProps.uri_attachment = .Fields("uri_attachment").Value & ""
      udtProps.envio_anonimo = .Fields("envio_anonimo").Value & ""
      udtProps.fecha_envio = .Fields("fecha_envio").Value
      udtProps.nombre_autor = .Fields("nombre_autor").Value & ""
      udtProps.nombre_topico = .Fields("nombre_topico").Value & ""
      udtProps.nombre_usuario = .Fields("nombre_usuario").Value & ""
      contenido = .Fields("contenido").Value & ""
      PBag.WriteProperty "Item" & lngIndex, SerializeVMensaje(udtProps, contenido)
      .MoveNext
    Wend
    .Close
  End With
  Set rs = Nothing
  PBag.WriteProperty "Count", lngIndex
  getMensajesTopico = PBag.Contents
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function

errhandler:
  App.LogEvent "VMensajePersist [getMensajesTopico()]: " & Err.Number & ": " & Err.Description
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function getMensaje(ByVal id_mensaje As Long) As String
  Dim rs As adodb.Recordset
  Dim strSQL As String
  Dim udtProps As VMensajeProps
  Dim PBag As PropertyBag
  Dim contenido As String

  On Error GoTo errhandler
  
  Set PBag = New PropertyBag
  strSQL = "Select t1.ID_MENSAJE, t1.ID_MENSAJE_ORIGINAL, t1.ID_USUARIO, " _
         & "t1.ASUNTO, t1.CONTENIDO, t1.INCLUIR_ORIGINAL, t1.PRIORIDAD, " _
         & "t1.FECHA_ENVIO, t1.ENVIO_ANONIMO, t1.ESTATUS ESTATUS_MENSAJE, " _
         & "t2.NOMBRE_CORTO NOMBRE_USUARIO, t2.EMAIL EMAIL_USUARIO, " _
         & "t1.ID_EMOTICON, t1.NOMBRE_AUTOR, t3.URI URI_ATTACHMENT, " _
         & "t4.NOMBRE NOMBRE_TOPICO " _
         & "From MENSAJE t1 INNER JOIN USUARIO t2 ON t1.ID_USUARIO = t2.ID_USUARIO " _
         & "INNER JOIN TOPICO t4 ON t1.ID_TOPICO = t4.ID_TOPICO " _
         & "LEFT OUTER JOIN ATTACHMENT t3 ON t1.ID_MENSAJE = t3.ID_MENSAJE " _
         & "Where t1.ID_MENSAJE= " & id_mensaje

  Set rs = New adodb.Recordset
  With rs
    .Open strSQL, DBCONNECTION, adOpenForwardOnly, adLockReadOnly
    udtProps.id_mensaje = .Fields("id_mensaje").Value
    udtProps.id_mensaje_original = Nvl(.Fields("id_mensaje_original").Value, 0)
    udtProps.id_emoticon = Nvl(.Fields("id_emoticon").Value, 0)
    udtProps.id_usuario = .Fields("id_usuario").Value
    udtProps.asunto = .Fields("asunto").Value & ""
    udtProps.email_usuario = .Fields("email_usuario").Value & ""
    udtProps.estatus_mensaje = .Fields("estatus_mensaje").Value
    udtProps.incluir_original = .Fields("incluir_original").Value
    udtProps.prioridad = Nvl(.Fields("prioridad").Value, 0)
    udtProps.uri_attachment = .Fields("uri_attachment").Value & ""
    udtProps.envio_anonimo = .Fields("envio_anonimo").Value
    udtProps.fecha_envio = .Fields("fecha_envio").Value
    udtProps.nombre_autor = .Fields("nombre_autor").Value & ""
    udtProps.nombre_topico = .Fields("nombre_topico").Value & ""
    udtProps.nombre_usuario = .Fields("nombre_usuario").Value & ""
    contenido = .Fields("contenido").Value & ""
    .Close
  End With
  Set rs = Nothing
  getMensaje = SerializeVMensaje(udtProps, contenido)
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function

errhandler:
  App.LogEvent "VMensajePersist [getMensaje()]: " & Err.Number & ": " & Err.Description
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Private Function SerializeVMensaje(ByRef udtProps As VMensajeProps, ByVal contenido As String) As String
  Dim udtData As VMensajeData
  Dim PBag As PropertyBag
  
  LSet udtData = udtProps
  Set PBag = New PropertyBag
  With PBag
    .WriteProperty "fixedlength_state", udtData.Buffer
    .WriteProperty "contenido_mensaje", contenido
    SerializeVMensaje = .Contents
  End With
  Set PBag = Nothing
End Function

Private Sub ObjectControl_Activate()
  Set mobjContext = GetObjectContext
  mflgInMTS = True
End Sub

Private Function ObjectControl_CanBePooled() As Boolean
  ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
  Set mobjContext = Nothing
End Sub




