VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "VSuscripcionPersist"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Implements ObjectControl
Private mobjContext As ObjectContext
Private mflgInMTS As Boolean

Public Function getAllForo(ByVal id_foro As Long) As String
  Dim rs As adodb.Recordset
  Dim strSQL As String
  Dim udtProps As VSuscripcionProps
  Dim lngIndex As Long
  Dim PBag As PropertyBag

  On Error GoTo errhandler
  
  Set PBag = New PropertyBag
  strSQL = "Select t1.NOMBRE_CORTO NOMBRE_CORTO_USUARIO, t1.NOMBRE_COMPLETO NOMBRE_COMPLETO_USUARIO, " _
         & "t1.EMAIL EMAIL_USUARIO, t2.* " _
         & "From USUARIO t1, SUSCRIPCION t2 " _
         & "Where t1.ID_USUARIO = t2.ID_USUARIO " _
         & "And t2.ID_FORO = " & id_foro & " " _
         & "Order By 1"

  Set rs = New adodb.Recordset
  With rs
    .Open strSQL, DBCONNECTION, adOpenForwardOnly, adLockReadOnly
    While Not .EOF
      lngIndex = lngIndex + 1
      udtProps.id_foro = .Fields("id_foro").Value
      udtProps.id_usuario = .Fields("id_usuario").Value
      udtProps.email_actualizaciones = .Fields("email_actualizaciones").Value & ""
      udtProps.email_anuncios = .Fields("email_anuncios").Value & ""
      udtProps.email_nuevos = .Fields("email_nuevos").Value & ""
      udtProps.email_usuario = .Fields("email_usuario").Value & ""
      udtProps.enviar_mensajes = .Fields("enviar_mensajes").Value & ""
      udtProps.estatus = .Fields("estatus").Value & ""
      udtProps.fecha_ultima_visita = .Fields("fecha_ultima_visita").Value
      udtProps.nombre_completo_usuario = .Fields("nombre_completo_usuario").Value & ""
      udtProps.nombre_corto_usuario = .Fields("nombre_corto_usuario").Value & ""
      udtProps.tipo = .Fields("tipo").Value & ""
      PBag.WriteProperty "Item" & lngIndex, SerializeVSuscripcion(udtProps)
      .MoveNext
    Wend
    .Close
  End With
  Set rs = Nothing
  PBag.WriteProperty "Count", lngIndex
  getAllForo = PBag.Contents
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function

errhandler:
  App.LogEvent "VSuscripcionPersist [getAllForo()]: " & Err.Number & ": " & Err.Description
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function getActivasForo(ByVal id_foro As Long) As String
  Dim rs As adodb.Recordset
  Dim strSQL As String
  Dim udtProps As VSuscripcionProps
  Dim lngIndex As Long
  Dim PBag As PropertyBag

  On Error GoTo errhandler
  
  Set PBag = New PropertyBag
  strSQL = "Select t1.NOMBRE_CORTO NOMBRE_CORTO_USUARIO, t1.NOMBRE_COMPLETO NOMBRE_COMPLETO_USUARIO, " _
         & "t1.EMAIL EMAIL_USUARIO, t2.* " _
         & "From USUARIO t1, SUSCRIPCION t2 " _
         & "Where t1.ID_USUARIO = t2.ID_USUARIO " _
         & "And t2.ID_FORO = " & id_foro & " " _
         & "And t2.ESTATUS = 'A' " _
         & "Order By 1"

  Set rs = New adodb.Recordset
  With rs
    .Open strSQL, DBCONNECTION, adOpenForwardOnly, adLockReadOnly
    While Not .EOF
      lngIndex = lngIndex + 1
      udtProps.id_foro = .Fields("id_foro").Value
      udtProps.id_usuario = .Fields("id_usuario").Value
      udtProps.email_actualizaciones = .Fields("email_actualizaciones").Value & ""
      udtProps.email_anuncios = .Fields("email_anuncios").Value & ""
      udtProps.email_nuevos = .Fields("email_nuevos").Value & ""
      udtProps.email_usuario = .Fields("email_usuario").Value & ""
      udtProps.enviar_mensajes = .Fields("enviar_mensajes").Value & ""
      udtProps.estatus = .Fields("estatus").Value & ""
      udtProps.fecha_ultima_visita = .Fields("fecha_ultima_visita").Value
      udtProps.nombre_completo_usuario = .Fields("nombre_completo_usuario").Value & ""
      udtProps.nombre_corto_usuario = .Fields("nombre_corto_usuario").Value & ""
      udtProps.tipo = .Fields("tipo").Value & ""
      PBag.WriteProperty "Item" & lngIndex, SerializeVSuscripcion(udtProps)
      .MoveNext
    Wend
    .Close
  End With
  Set rs = Nothing
  PBag.WriteProperty "Count", lngIndex
  getActivasForo = PBag.Contents
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function

errhandler:
  App.LogEvent "VSuscripcionPersist [getActivasForo()]: " & Err.Number & ": " & Err.Description
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Public Function getActivasNormSuspForo(ByVal id_foro As Long) As String
  Dim rs As adodb.Recordset
  Dim strSQL As String
  Dim udtProps As VSuscripcionProps
  Dim lngIndex As Long
  Dim PBag As PropertyBag

  On Error GoTo errhandler
  
  Set PBag = New PropertyBag
  strSQL = "Select t1.NOMBRE_CORTO NOMBRE_CORTO_USUARIO, t1.NOMBRE_COMPLETO NOMBRE_COMPLETO_USUARIO, " _
         & "t1.EMAIL EMAIL_USUARIO, t2.* " _
         & "From USUARIO t1, SUSCRIPCION t2 " _
         & "Where t1.ID_USUARIO = t2.ID_USUARIO " _
         & "And t2.ID_FORO = " & id_foro & " " _
         & "And t2.ESTATUS = 'A' " _
         & "And t2.TIPO IN ('N','S') " _
         & "Order By 1"

  Set rs = New adodb.Recordset
  With rs
    .Open strSQL, DBCONNECTION, adOpenForwardOnly, adLockReadOnly
    While Not .EOF
      lngIndex = lngIndex + 1
      udtProps.id_foro = .Fields("id_foro").Value
      udtProps.id_usuario = .Fields("id_usuario").Value
      udtProps.email_actualizaciones = .Fields("email_actualizaciones").Value & ""
      udtProps.email_anuncios = .Fields("email_anuncios").Value & ""
      udtProps.email_nuevos = .Fields("email_nuevos").Value & ""
      udtProps.email_usuario = .Fields("email_usuario").Value & ""
      udtProps.enviar_mensajes = .Fields("enviar_mensajes").Value & ""
      udtProps.estatus = .Fields("estatus").Value & ""
      udtProps.fecha_ultima_visita = .Fields("fecha_ultima_visita").Value
      udtProps.nombre_completo_usuario = .Fields("nombre_completo_usuario").Value & ""
      udtProps.nombre_corto_usuario = .Fields("nombre_corto_usuario").Value & ""
      udtProps.tipo = .Fields("tipo").Value & ""
      PBag.WriteProperty "Item" & lngIndex, SerializeVSuscripcion(udtProps)
      .MoveNext
    Wend
    .Close
  End With
  Set rs = Nothing
  PBag.WriteProperty "Count", lngIndex
  getActivasNormSuspForo = PBag.Contents
  If mflgInMTS Then mobjContext.SetComplete
  Exit Function

errhandler:
  App.LogEvent "VSuscripcionPersist [getActivasNormSuspForo()]: " & Err.Number & ": " & Err.Description
  Set rs = Nothing
  If mflgInMTS Then mobjContext.SetAbort
  Err.Raise Err.Number
End Function

Private Function DeserializeVSuscripcion(ByVal Buffer As String) As VSuscripcionProps
  Dim udtData As VSuscripcionData
  Dim PBag As PropertyBag
  Dim arrbyte_buff() As Byte
  
  arrbyte_buff = Buffer
  Set PBag = New PropertyBag
  With PBag
    .Contents = arrbyte_buff
    udtData.Buffer = .ReadProperty("fixedlength_state")
  End With
  Set PBag = Nothing
  LSet DeserializeVSuscripcion = udtData
End Function

Private Function SerializeVSuscripcion(ByRef udtProps As VSuscripcionProps) As String
  Dim udtData As VSuscripcionData
  Dim PBag As PropertyBag
  
  LSet udtData = udtProps
  Set PBag = New PropertyBag
  With PBag
    .WriteProperty "fixedlength_state", udtData.Buffer
    SerializeVSuscripcion = .Contents
  End With
  Set PBag = Nothing
End Function

Private Sub ObjectControl_Activate()
  Set mobjContext = GetObjectContext
  mflgInMTS = True
End Sub

Private Function ObjectControl_CanBePooled() As Boolean
  ObjectControl_CanBePooled = False
End Function

Private Sub ObjectControl_Deactivate()
  Set mobjContext = Nothing
End Sub








