VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Settings"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Function getSetting(key As String) As String
  Dim lRetVal As Long    'result of the API functions
  Dim hKey As Long       'handle of opened key
  Dim value As String
  Dim masterKey As String, detailKey As String
  
  On Error GoTo ErrorHandler
  masterKey = "Software\NetApplications\webforums_asp\" & Trim(Replace(Left(key, InStrRev(key, ".") - 1), ".", "\"))
  detailKey = Trim(Mid(key, InStrRev(key, ".") + 1))
  If Len(masterKey) = 0 Or Len(detailKey) = 0 Then Err.Raise vbObjectError + 1001
  lRetVal = RegOpenKeyEx(HKEY_LOCAL_MACHINE, masterKey, 0, KEY_QUERY_VALUE, hKey)
  If lRetVal <> ERROR_SUCCESS Then Err.Raise vbObjectError + 1001
  lRetVal = QueryValueEx(hKey, detailKey, value)
  If lRetVal <> ERROR_SUCCESS Then Err.Raise vbObjectError + 1001
  RegCloseKey hKey
  getSetting = value
  Exit Function

ErrorHandler:
  On Error Resume Next
  If hKey > 0 Then RegCloseKey hKey
  App.LogEvent "Settings [setSetting()]: Error retrieving setting " & key
  On Error GoTo 0
  Err.Raise vbObjectError + 1001, App.EXEName, "Error retrieving setting " & key
End Function

Public Sub setSetting(key As String, value As String)
  Dim lRetVal As Long    'result of the API functions
  Dim hKey As Long       'handle of opened key
  Dim masterKey As String, detailKey As String
  
  On Error GoTo ErrorHandler
  masterKey = "Software\NetApplications\webforums_asp\" & Trim(Replace(Left(key, InStrRev(key, ".") - 1), ".", "\"))
  detailKey = Trim(Mid(key, InStrRev(key, ".") + 1))
  If Len(masterKey) = 0 Or Len(detailKey) = 0 Then Err.Raise vbObjectError + 1001
  lRetVal = RegOpenKeyEx(HKEY_LOCAL_MACHINE, masterKey, 0, KEY_QUERY_VALUE Or KEY_SET_VALUE, hKey)
  If lRetVal <> ERROR_SUCCESS Then Err.Raise vbObjectError + 1001
  lRetVal = SetValueEx(hKey, detailKey, value)
  If lRetVal <> ERROR_SUCCESS Then Err.Raise vbObjectError + 1001
  RegCloseKey hKey
  Exit Sub

ErrorHandler:
  On Error Resume Next
  If hKey > 0 Then RegCloseKey hKey
  App.LogEvent "Settings [setSetting()]: Error saving setting " & key
  On Error GoTo 0
  Err.Raise vbObjectError + 1001, App.EXEName, "Error saving setting " & key
End Sub
