VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "NavComboBox"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Implements INavItem

Private strHTML As String
Private strCmdKey As String
Private strParamName As String
Private strHint As String
Private strText As String

Public Sub Init(cmdKey As String, paramName As String, hint As String, text As String, provider As ICatalogProvider)
  strCmdKey = cmdKey
  strParamName = paramName
  strHint = hint
  strText = text
  INavItem_rebuildHTML
End Sub

Private Property Get INavItem_HTML() As String
  INavItem_HTML = strHTML
End Property

Private Sub INavItem_rebuildHTML()
  Dim hasPrevious As Boolean
  Dim cat() As Catalog
  Dim i As Integer
  Dim objContext As COMSVCSLib.objectContext
  Dim objServer As ASPTypeLibrary.Server
  
  Set objContext = GetObjectContext
  Set objServer = objContext("Server")
  
  hasPrevious = False
  strHTML = "writeToolCombo('" & strCmdKey & "','" & strText & "','" & _
            strHint & "','" & strParamName & "',new Array("
  For i = LBound(cat) To UBound(cat)
    If hasPrevious Then strHTML = strHTML & ","
    strHTML = strHTML & "new Array('" & objServer.HTMLEncode(cat(i).Identifier) & _
              "','" & objServer.HTMLEncode(cat(i).Name) & "')"
  Next i
  strHTML = strHTML & "));" & vbCrLf
End Sub


