// Copyright (c) 2001 NetApplications
package com.netapplications.webforums_jsp.domain;

import java.util.Date;
import java.io.Serializable;

public class VistaBusquedaMensaje extends Object implements Serializable {
  private int id_foro;
  private String nombre_foro;
  private int id_usuario;
  private String nombre_usuario;
  private int id_topico;
  private String nombre_topico;
  private int id_mensaje;
  private String asunto;
  private String envio_anonimo;
  private String nombre_autor;
  private Date fecha_envio;

  public VistaBusquedaMensaje() {
    id_foro = 0;
    nombre_foro = "";
    id_usuario = 0;
    nombre_usuario = "";
    id_topico = 0;
    nombre_topico = "";
    id_mensaje = 0;
    asunto = "";
    envio_anonimo = "N";
    nombre_autor = "";
    fecha_envio = new Date();
  }

  public synchronized int getId_foro() {
    return id_foro;
  }

  public synchronized void setId_foro(int newId_foro) {
    id_foro = newId_foro;
  }

  public synchronized String getNombre_foro() {
    return nombre_foro;
  }

  public synchronized void setNombre_foro(String newNombre_foro) {
    nombre_foro = newNombre_foro;
  }

  public synchronized int getId_usuario() {
    return id_usuario;
  }

  public synchronized void setId_usuario(int newId_usuario) {
    id_usuario = newId_usuario;
  }

  public synchronized String getNombre_usuario() {
    return nombre_usuario;
  }

  public synchronized void setNombre_usuario(String newNombre_usuario) {
    nombre_usuario = newNombre_usuario;
  }

  public synchronized int getId_topico() {
    return id_topico;
  }

  public synchronized void setId_topico(int newId_topico) {
    id_topico = newId_topico;
  }

  public synchronized String getNombre_topico() {
    return nombre_topico;
  }

  public synchronized void setNombre_topico(String newNombre_topico) {
    nombre_topico = newNombre_topico;
  }

  public synchronized int getId_mensaje() {
    return id_mensaje;
  }

  public synchronized void setId_mensaje(int newId_mensaje) {
    id_mensaje = newId_mensaje;
  }

  public synchronized String getAsunto() {
    return asunto;
  }

  public synchronized void setAsunto(String newAsunto) {
    asunto = newAsunto;
  }

  public synchronized String getEnvio_anonimo() {
    if (envio_anonimo.equalsIgnoreCase("N")) {
      return envio_anonimo;
    } else {
      return "N";
    }
  }

  public synchronized void setEnvio_anonimo(String newEnvio_anonimo) {
    envio_anonimo = newEnvio_anonimo;
  }

  public synchronized String getNombre_autor() {
    return nombre_autor;
  }

  public synchronized void setNombre_autor(String newNombre_autor) {
    nombre_autor = newNombre_autor;
  }

  public synchronized Date getFecha_envio() {
    return fecha_envio;
  }

  public synchronized void setFecha_envio(Date newFecha_envio) {
    fecha_envio = newFecha_envio;
  }

  public synchronized String getAutor() {
    if (envio_anonimo==null || envio_anonimo.equalsIgnoreCase("N")) {
      return nombre_usuario;
    } else {
      return nombre_autor;
    }
  }
}
