
// Copyright (c) 2001 NetApplications
package com.netapplications.webforums_jsp.domain;

import java.util.Date;
import java.io.Serializable;
import com.netapplications.webforums_jsp.util.StringUtils;

public class VistaTopico extends Object implements Serializable {
  private int id_topico;
  private String nombre_topico;
  private int num_respuestas;
  private int id_usuario;
  private String nombre_usuario;
  private String email_usuario;
  private Date fecha_creacion;
  private Date fecha_ultimo_mensaje;

  public VistaTopico() {
    id_topico = 0;
    nombre_topico = "";
    num_respuestas = 0;
    id_usuario = 0;
    nombre_usuario = "";
    email_usuario = "";
    fecha_creacion = new Date();
    fecha_ultimo_mensaje = new Date();
  }

  public synchronized int getId_topico() {
    return id_topico;
  }

  public synchronized void setId_topico(int newId_topico) {
    id_topico = newId_topico;
  }

  public synchronized String getNombre_topico() {
    return nombre_topico;
  }

  public synchronized void setNombre_topico(String newnombre_topico) {
    nombre_topico = newnombre_topico;
  }

  public synchronized int getNum_respuestas() {
    return num_respuestas;
  }

  public synchronized void setNum_respuestas(int newNum_respuestas) {
    num_respuestas = newNum_respuestas;
  }

  public synchronized int getId_usuario() {
    return id_usuario;
  }

  public synchronized void setId_usuario(int newId_usuario) {
    id_usuario = newId_usuario;
  }

  public synchronized String getNombre_usuario() {
    return nombre_usuario;
  }

  public synchronized void setNombre_usuario(String newnombre_usuario) {
    nombre_usuario = newnombre_usuario;
  }

  public synchronized String getEmail_usuario() {
    return email_usuario;
  }

  public synchronized String getEmail_nombre_usuario() {
    if (email_usuario!=null
        && email_usuario.indexOf("@")>0
        && email_usuario.indexOf("@")<email_usuario.length()-1) {
      return "<a href=\"mailto:" + email_usuario + "\">" + nombre_usuario + "</a>";
    } else {
      return nombre_usuario;
    }
  }

  public synchronized void setEmail_usuario(String newEmail_usuario) {
    email_usuario = newEmail_usuario;
  }

  public synchronized Date getFecha_creacion() {
    return fecha_creacion;
  }

  public synchronized void setFecha_creacion(Date newFecha_creacion) {
    fecha_creacion = newFecha_creacion;
  }

  public synchronized Date getFecha_ultimo_mensaje() {
    return fecha_ultimo_mensaje;
  }

  public synchronized void setFecha_ultimo_mensaje(Date newFecha_ultimo_mensaje) {
    fecha_ultimo_mensaje = newFecha_ultimo_mensaje;
  }
}
