// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.util;

import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;

public class CookieUtils extends Object {
  public static boolean isFoundCookie(HttpServletRequest req, String name) {
    Cookie[] cookies = req.getCookies();
    for (int i=0;i<cookies.length;i++) {
      if (cookies[i].getName().equalsIgnoreCase(name)) {
        return true;
      }
    }
    return false;
  }

  public static String getCookieValue(HttpServletRequest req, String name) {
    Cookie[] cookies = req.getCookies();
    for (int i=0;i<cookies.length;i++) {
      if (cookies[i].getName().equalsIgnoreCase(name)) {
        return cookies[i].getValue();
      }
    }
    return null;
  }
}

