// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.util;

import javax.servlet.http.HttpServletRequest;

public class PagedIteratorUtils extends Object {
  public static int getCurrentPage(HttpServletRequest req, PagedIterator pagIter) {
    try {
      int currPage = Integer.parseInt(req.getParameter("page"));
      if (currPage > pagIter.pagesCount()) {
        currPage = Math.max(pagIter.pagesCount(),1);
      }
      return currPage;
    } catch (Exception e) {
      return 1;
    }
  }

  public static String getPagesLinksHTML(PagedIterator pagIter, int currPage) {
    if (pagIter.pagesCount()>1) {
      StringBuffer retVal = new StringBuffer("<TABLE align=\"center\" border=\"0\" cellPadding=\"0\" cellSpacing=\"0\" width=\"95%\"><TR><TD class=\"PagesLinks\">");
      retVal.append(pagIter.length());
      retVal.append(" Items, ");
      retVal.append(pagIter.pagesCount());
      retVal.append(" Pages:&nbsp;");
      if (currPage>1) {
        retVal.append("<A href=\"javascript:go_page(");
        retVal.append(currPage - 1);
        retVal.append(")\">[<< Prev]</A>&nbsp;");
      }
      for (int i=1;i<=pagIter.pagesCount();i++) {
        if (i==currPage) {
          retVal.append("<B>");
          retVal.append(i);
          retVal.append("</B>&nbsp;");
        } else {
          retVal.append("<A href=\"javascript:go_page(");
          retVal.append(i);
          retVal.append(")\">");
          retVal.append(i);
          retVal.append("</A>&nbsp;");
        }
      }
      if (currPage<pagIter.pagesCount()) {
        retVal.append("<A href=\"javascript:go_page(");
        retVal.append(currPage + 1);
        retVal.append(")\">[Next >>]</A><BR>");
      }
      retVal.append("</TD></TR></TABLE>");
      return retVal.toString();
    } else {
      return "";
    }
  }
}

