// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.util;

public class  StringUtils extends Object {

// direfente de java.net.URLEncoder
  public static String URLItemEncode(String input) {
    if (input == null) {
      return (String) null;
    }
    StringBuffer filtered = new StringBuffer(input.length());
    char c;
    for (int i=0; i<input.length(); i++) {
      c = input.charAt(i);
      if (c == ' ') {
        filtered.append("%20");
      } else if (c == '&') {
        filtered.append("%26");
      } else if (c == '#') {
        filtered.append("%23");
/*
      } else if (c == '\"') {
        filtered.append("%22");
*/
      } else if (c == ';') {
        filtered.append("%3B");
      } else if (c == ':') {
        filtered.append("%3A");
/*
      } else if (c == '\'') {
        filtered.append("%27");
*/
      } else if (c == '%') {
        filtered.append("%25");
      } else if (c == '?') {
        filtered.append("%2C");
/*
      } else if (c == '_') {
        filtered.append("%5F");
*/
      } else {
        filtered.append(c);
      }
    }
    return filtered.toString();
  }

  public static String JavaEncode(String input) {
    if (input == null) {
      return (String) null;
    }
    StringBuffer filtered = new StringBuffer(input.length());
    char c;
    for (int i=0; i<input.length(); i++) {
      c = input.charAt(i);
      if (c == '\'') {
        filtered.append("\\\'");
      } else if (c == '\"') {
        filtered.append("\\\"");
      } else if (c == '\b') {
        filtered.append("\\b");
      } else if (c == '\f') {
        filtered.append("\\f");
      } else if (c == '\n') {
        filtered.append("\\n");
      } else if (c == '\r') {
        filtered.append("\\r");
      } else if (c == '\t') {
        filtered.append("\\t");
      } else {
        filtered.append(c);
      }
    }
    return filtered.toString();
  }

  public static String HTMLEncode(String input) {
    if (input == null) {
      return (String) null;
    }
    StringBuffer filtered = new StringBuffer(input.length());
    char c;
    for (int i=0; i<input.length(); i++) {
      c = input.charAt(i);
      if (c == '<') {
        filtered.append("&lt;");
      } else if (c == '>') {
        filtered.append("&gt;");
      } else if (c == '"') {
        filtered.append("&quot;");
      } else if (c == '&') {
        filtered.append("&amp;");
      } else {
        filtered.append(c);
      }
    }
    return filtered.toString();
  }

  public static String validAttahcmentName(String name) {
    StringBuffer filtered = new StringBuffer();
    char c;
    for (int i=0; i<name.length(); i++) {
      c = name.charAt(i);
      if (c == '%') {
        filtered.append("%25");
      } else if (c == ' ') {
        filtered.append("%20");
      } else {
        filtered.append(c);
      }
    }
    return filtered.toString();
  }

  public static String HTMLBreakLines(String input) {
    if (input == null) {
      return (String) null;
    }
    StringBuffer output = new StringBuffer(input.length());
    output.append(input);
    int i;
    while ((i = output.toString().indexOf("\r\n"))>=0) {
      output.replace(i, i+1, "<BR>");
    }
    while ((i = output.toString().indexOf("\n\r"))>=0) {
      output.replace(i, i+1, "<BR>");
    }
    return output.toString();
  }

  public static String ReplyText(String input) {
    if (input == null) {
      return (String) null;
    }
    StringBuffer output = new StringBuffer(input.length()+2);
    output.append('>');
    output.append(input);
    int i = output.toString().indexOf("\r\n");
    while (i>=0) {
      output.insert(i+2, '>');
      i = output.toString().indexOf("\r\n",++i);
    }
    i = output.toString().indexOf("\n\r");
    while (i>=0) {
      output.insert(i+2, '>');
      i = output.toString().indexOf("\n\r",++i);
    }
    return output.toString();
  }

  public static void main(String[] args){
    //System.out.println(StringUtils.validAttahcmentName("a83724 - Oracle8i JDBC Developer\'s Guide and Reference .pdf"));
    //System.out.println(StringUtils.validAttahcmentName("%%a83724 - Oracle8i JDBC Developer\'s Guide and Reference .pdf"));
    System.out.println(StringUtils.ReplyText("hola \r\namigos\r\ncomo les fue"));
  }
}

 