// Copyright (c) 2001 NetApplication
package com.netapplications.webforums_jsp.view;

import java.util.Iterator;
import java.util.Vector;

public class NavItemsVector extends Object {

  private class NavItemContainer {
    protected INavItem item;
    protected String roles;
    protected String commands;
    protected NavItemContainer(INavItem item, String roles, String commands) {
      this.item = item;
      this.roles = roles;
      this.commands = commands;
    }
  }

  private Vector vector;

  public NavItemsVector() {
    vector = new Vector();
  }

  public void addNavItem(INavItem item, String roles, String commands) {
    if (item!=null) {
      vector.add(new NavItemContainer(item, roles, commands));
    }
  }

  public String getHTML(String rol, String cmdKey) {
    NavItemContainer itemCont;
    Iterator iter = vector.iterator();
    StringBuffer codeHTML = new StringBuffer(100);
//    codeHTML.append("<TABLE align=\"left\" border=\"0\" cellPadding=\"0\" cellSpacing=\"5\" height=\"35\">");
//    codeHTML.append("<TR height=\"100%\" align=\"center\" valign=\"middle\">");
//    codeHTML.append("<SCRIPT language=\"javascript\" src=\"javascript/toolbar.js\"></SCRIPT>\r\n");
    codeHTML.append("<SCRIPT language=\"javascript\">\r\n");
    codeHTML.append("<!--\r\n");
    codeHTML.append("writeToolbarStart();\r\n");
    while (iter.hasNext()) {
      itemCont = (NavItemContainer) iter.next();
      if ((itemCont.roles!=null && itemCont.roles.length()>0 && (itemCont.roles+",").indexOf(rol+",")>=0)
        &&(itemCont.commands!=null && itemCont.commands.length()>0 && (itemCont.commands+",").indexOf(cmdKey+",")>=0)) {
        // Si debe de ir el item
//        codeHTML.append("<TD  class=\"ButtonsNav\" width=\"100\">");
        codeHTML.append(itemCont.item.getHTML());
//        codeHTML.append("</TD>");
      }
    }
    codeHTML.append("writeToolbarEnd();\r\n");
    codeHTML.append("//-->\r\n");
    codeHTML.append("</SCRIPT>\r\n");
//    codeHTML.append("</TR></TABLE>");
    return codeHTML.toString();
  }

  public synchronized void rebuildHTML() {
    NavItemContainer itemCont;
    Iterator iter = vector.iterator();
    while (iter.hasNext()) {
      itemCont = (NavItemContainer) iter.next();
      itemCont.item.rebuildHTML();
    }
  }

  public static void main(String[] argc) {
    NavItemsVector     navitems = new NavItemsVector();
    //...
    System.out.println(navitems.getHTML("AD","go-home"));
  }
}

